/**************************************
 * $Author: kaneda $
 * $Date: 2003/02/12 12:45:18 $
 **************************************/

/* phnxd.h */

#ifndef __PHOENIX_H__
#define __PHOENIX_H__

#include "ph_util.h"
#include "ph_pt2pt.h"
#include "ph_phnxd.h"


/* Macro Values */


/* Miscellaneous constants */


/* Basic Types */
typedef ph_vp_set_t		ph_vps_t;


/* Structures */

#ifdef __cplusplus 
extern "C"{
#endif
  void ph_initialize(int listen_port);
  void ph_initialize2(int listen_port_lower, int listen_port_upper);
  void ph_add_contact_point(char * addr, int port, ph_addr_type_t addr_type, ...);
  void ph_assume_vps(ph_vps_t vp_set);
  void ph_release_vps(ph_vps_t vp_set);
  ph_vps_t ph_get_assumed_vps();
  ph_vp_t ph_get_resource_vp();

  void ph_invalidate_routing();
  void ph_finalize();
  int ph_messages_is_empty();
  void ph_load_messages(char * filename);
  void ph_store_messages(char * filename);
  
  void ph_send(ph_vp_t dest, char * body, size_t len, int tag);
  ssize_t ph_recv(char ** body, int tag);
  ssize_t ph_try_recv(char ** body, int tag);
  
  ph_vp_t ph_get_random_vp();
  ph_vp_t ph_get_temp_vp();
  ph_pt2pt_t ph_get_pt2pt();
  
  ph_vps_t ph_vps_dup(ph_vps_t vps);
  ph_vps_t ph_vps_make_empty();
  ph_vps_t ph_vps_make_singleton(ph_vp_t vp);
  ph_vps_t ph_vps_make_range(ph_vp_t l, ph_vp_t u);

  void ph_vps_dispose(ph_vps_t vps);
  
  ph_vps_t ph_vps_make_union(ph_vps_t p, ph_vps_t q);
  ph_vps_t ph_vps_make_diff(ph_vps_t p, ph_vps_t q);
  ph_vp_t ph_vps_get_min_elem(ph_vps_t vps);
  ph_vp_t ph_vps_get_max_elem(ph_vps_t vps);
  ph_vp_t ph_vps_get_any_elem(ph_vps_t vps);
  
  
  int ph_vps_is_empty(ph_vps_t vps);
  int ph_vps_is_sub(ph_vps_t p, ph_vps_t q);
  int ph_vps_is_equal(ph_vps_t p, ph_vps_t q);
  int ph_vps_is_exclusive(ph_vps_t p, ph_vps_t q);
  int ph_vps_is_member(ph_vps_t vps, ph_vp_t vp);

#ifdef PH_VIEWER
  void ph_viewer_initialize(int viewer_update_interval, char * addr, int port, ph_addr_type_t addr_type, ...);
  void ph_viewer_send(void * body, size_t len);
#endif

#ifdef __cplusplus
}
#endif
#endif




