/**************************************
 * $Author: kaneda $
 * $Date: 2003/02/12 12:45:19 $
 **************************************/

/* main.c */

#include "phoenix.h"




void my_print(ph_vp_set_t vp_set) {
  ph_vp_range_cell_t p;

  assert(vp_set != NULL);
  printf("[vp_set ");
  for (p = vp_set->head; p != NULL; p = p->next) {
    printf("("  PH_LLD "," PH_LLD ")%s", p->self->lower, p->self->upper, ((p->next != NULL) ? "," : ""));
  }

  printf("]\n");
}



int main(int argc, char * argv[], char * envp[]) {
  int no, i;
  ph_pt2pt_t pt2pt;

  assert(argc == 2);
  no = atoi(argv[1]);


  {
    char hostname[8192];
        
    memset(hostname, 0, 8192);
    gethostname(hostname, 8192);
    
    if (strncmp(hostname, "csc", 3) == 0) {
      fprintf(stderr, "csc\n");
      ph_initialize(30000);
      

      no = atoi(hostname +3) + 10000;


      for (i = 0; i <= 128; i++) {
	char s[8192];
	
	memset(s, 0, 8192);
	snprintf(s, 8192, "csc%03d", i);
	ph_add_contact_point(s, 30000, tcp);
      }
      
      ph_add_contact_point("133.11.23.16", 30000, ssh, "kanedacc");  // SF15K
      //ph_add_contact_point("tuba", 30000, ssh, "kaneda");

      for (i = 0; i < 16; i++) {
	char s[8192];
	
	memset(s, 0, 8192);
	snprintf(s, 8192, "uguisu%02d.kototoi.org", i);
	ph_add_contact_point(s, 30000, ssh, "kaneda");
      }

      if (no < 10010) {
	//ph_viewer_initialize(10, "tuba.is.s.u-tokyo.ac.jp", 41000, ssh, "kaneda");
      }
      


    } else if (strncmp(hostname, "tuba", 4) == 0) {    
      fprintf(stderr, "tuba\n");
      ph_initialize2(30000, 30128);
      for (i = 0; i <= 32; i++) {
	ph_add_contact_point("localhost", 30000 + i, tcp);
	//ph_add_contact_point("133.11.23.16", 30000+ i, ssh, "kanedacc");  // SF15K
      }
      //ph_viewer_initialize(3, "localhost", 41000, tcp);


    } else if (strncmp(hostname, "beatrice", 8) == 0) {    
      fprintf(stderr, "beatrice\n");
      ph_initialize2(30000, 30128);
      for (i = 0; i <= 4; i++) {
	ph_add_contact_point("localhost", 30000 + i, tcp);
      }

    } else if (strncmp(hostname, "istsun", 6) == 0) {    
      fprintf(stderr, "istsun\n");
      ph_initialize2(30000, 30128);
      for (i = 0; i <= 32; i++) {
	ph_add_contact_point("localhost", 30000 + i, tcp);
	//ph_add_contact_point("tuba.is.s.u-tokyo.ac.jp", 30000 + i, ssh, "kaneda");
      }
      //ph_viewer_initialize(3, "tuba.is.s.u-tokyo.ac.jp", 41000, ssh, "kaneda");

    } else if (strncmp(hostname, "uguisu", 6) == 0) {    
      fprintf(stderr, "uguisu\n");
      ph_initialize(30000);
      for (i = 0; i < 16; i++) {
	char s[8192];
      
	memset(s, 0, 8192);
	snprintf(s, 8192, "uguisu%02d.kototoi.org", i);
	ph_add_contact_point(s, 30000, tcp);
      }

      //      for (i = 0; i < 32; i++) {
      for (i = 0; i < 1; i++) {
	ph_add_contact_point("133.11.23.16", 30000+ i, ssh, "kanedacc");  // SF15K
      }

      //ph_viewer_initialize(3, "tuba.is.s.u-tokyo.ac.jp", 41000, ssh, "kaneda");


    } else if ((strncmp(hostname, "toki", 4) == 0) || (strncmp(hostname, "hibari", 6) == 0) || (strncmp(hostname, "tsubame", 7) == 0)) {    
      fprintf(stderr, "toki\n");
      ph_initialize(30000);
      for (i = 0; i < 16; i++) {
	char s[8192];

	ph_add_contact_point("toki", 30000, tcp);
      
	memset(s, 0, 8192);
	snprintf(s, 8192, "uguisu%02d", i);
	ph_add_contact_point(s, 30000, tcp);


	memset(s, 0, 8192);
	snprintf(s, 8192, "tsubame%02d", i);
	ph_add_contact_point(s, 30000, tcp);


	memset(s, 0, 8192);
	snprintf(s, 8192, "hibari%02d", i);
	ph_add_contact_point(s, 30000, tcp);
      }
    }
  }


  //ph_initialize(30000 + no);

  //ph_debug_set_mode(1);

  //ph_viewer_initialize(10, "csc000.is.s.u-tokyo.ac.jp", 41000, tcp);
  //ph_viewer_initialize(5, "toki.kototoi.org", 41000, tcp);

  /*
  for (i = 0; i < 10; i++) {
    ph_add_contact_point("localhost", 30000 + i, tcp);
  }
  */



    
  /*

  
  switch (no) {
  case 0:
    ph_add_contact_point("localhost", 40000 + 3, ssh, "kaneda");
    ph_add_contact_point("localhost", 40000 + 4, ssh, "kaneda");
    //ph_add_contact_point("localhost", 40000 + 5, ssh, "kaneda");
    break;
  case 3:
    //ph_add_contact_point("localhost", 40000 + 0, ssh, "kaneda");
    //ph_add_contact_point("localhost", 40000 + 1, ssh, "kaneda");
    //ph_add_contact_point("localhost", 40000 + 2, ssh, "kaneda");
    break;
  }


  switch (no) {
  case 0:
  case 1:
  case 2:
    ph_add_contact_point("localhost", 40000 + 0, tcp);
    ph_add_contact_point("localhost", 40000 + 1, tcp);
    ph_add_contact_point("localhost", 40000 + 2, tcp);
    break;
  case 3:
  case 4:
  case 5:
    ph_add_contact_point("localhost", 40000 + 3, tcp);
    ph_add_contact_point("localhost", 40000 + 4, tcp);
    ph_add_contact_point("localhost", 40000 + 5, tcp);
    break;
  }
  */
  
  ph_assume_vps(ph_vps_make_singleton(no));
  
  while (1) {
    sleep(10000);
  }

  return 0;
}  

