/**************************************
 * $Author: kaneda $
 * $Date: 2002/11/07 05:04:53 $
 **************************************/

/* auth.c */

#include "ph_pt2pt.h"


#define PH_COOKIE_FILE_NAME		".phoenix"

int is_enable_auth = 1;


/* ph_pt2pt_t is ...*/
struct ph_cookie {
  int a;
  int b;
};

typedef struct ph_cookie	* ph_cookie_t;



/* MIT-MAGIC-COOKIE-1 (xauth) authentication */

/* 
   connection  accpet  cookie ǧڤ뤳Ȥˤäơ
   malicious machine ³򤱤
*/


/* 
   This function is called when the daemon starts.
   Write cookie to an appropriate file whose permission does not allow any other users to read/write.
 */
void ph_auth_create_cookie() {
  int fd;
  char pth[PH_BUFSIZE], * home_pth;

  if (is_enable_auth == 0) {
    return;
  }


  /* set up a filename. */
  ph_mzero(pth, PH_BUFSIZE);
  home_pth = ph_getenv("HOME");
  snprintf(pth, PH_BUFSIZE, "%s/" PH_COOKIE_FILE_NAME, home_pth);

  
  /* write cookie to the file */
  fd = ph_open(pth, O_WRONLY | O_CREAT | O_TRUNC | O_NOCTTY, 600);
  write(fd, "test", 5);
  ph_close(fd);
}



void ph_auth_get_cookie(ph_addr_t addr) {
  if (is_enable_auth == 0) {
    return;
  }

  /* get addr's cookie by
        - reading local file
        - using rsh/ssh to addr

    new cookie is saved on local cookie file
  */
}




void ph_auth_send_cookie(ph_pt2pt_t pt2pt, ph_conn_t conn) {
  if (is_enable_auth == 0) {
    return;
  }

  /* This function is called soon after a connection is established
   Send cookie to a remote host. 
   if daemon fail to authenticate, get a newly created cookie
  */
  

}

/* confirm that the cookie that was sent by remote machine is equal to the cookie that the local machine has */
void ph_auth_recv_cookie(ph_pt2pt_t pt2pt, ph_conn_t conn, ph_cookie_t cookie) {
  if (is_enable_auth == 0) {
    ph_conn_set_is_authed(conn, 1);
  }

  
  return 1;
}













