/**************************************
 * $Author: tau $
 * $Date: 2002/12/06 17:23:58 $
 **************************************/

/* debug.c */

#include "ph_util.h"

static int is_verbose = 0;

void ph_debug_set_mode(int mode) {
  is_verbose = mode;
}

int ph_debug_get_mode() {
  return is_verbose;
}

/* tau : if set, use escape sequence to make debug msgs color.
   this does not work well in some terminals (like emacs *shell* buffer). 
   this is a very tentative fix to supress escape sequences. there will be
   a better design... */
static int use_color = 1;

void ph_debug_set_color_mode(int mode) {
  use_color = mode;
}

int ph_debug_get_color_mode() {
  return use_color;
}

void ph_debug_print(char * fmt, ...) {
  va_list	ap;

  if (is_verbose == 0) {
    return;
  }

  va_start(ap, fmt);
  vprintf(fmt, ap);
  fflush(stdout); 	/* make sure all output is out*/
  va_end(ap);
}


void ph_debug_print2(char * fmt, ...) {
  va_list	ap;

  if (is_verbose == 0) {
    return;
  }

  if (use_color) printf("\033[02;36m");

  va_start(ap, fmt);
  vprintf(fmt, ap);
  fflush(stdout); 	/* make sure all output is out*/
  va_end(ap);

  if (use_color) printf("\033[00m");
}


void ph_debug_print3(char * fmt, ...) {
  va_list	ap;

  if (is_verbose == 0) {
    return;
  }

  if (use_color) printf("\033[02;32m");

  va_start(ap, fmt);
  vprintf(fmt, ap);
  fflush(stdout); 	/* make sure all output is out*/
  va_end(ap);

  if (use_color) printf("\033[00m");
}


void ph_debug_print4(char * fmt, ...) {
  va_list	ap;

  if (is_verbose == 0) {
    return;
  }

  if (use_color) printf("\033[02;35m");

  va_start(ap, fmt);
  vprintf(fmt, ap);
  fflush(stdout); 	/* make sure all output is out*/
  va_end(ap);

  if (use_color) printf("\033[00m");
}


void ph_debug_print_message(pthread_mutex_t mp, char * buf, int len) {
  int i;

  if (is_verbose == 0) {
    return;
  }

  ph_pthread_mutex_lock(&mp);

  ph_debug_print3("[%d]\"", len);
  for (i = 0; (i < 100) && (i < len); i++) {
    if (buf[i] == '\n') {
      ph_debug_print3(" \\ ");
    } else if (buf[i] == '\0') {
      break;
      //ph_debug_print3("%c", " ");
    } else {
      ph_debug_print3("%c", buf[i]);
    }
  }
  ph_debug_print3("\"\n");
  ph_pthread_mutex_unlock(&mp);
}
