/**************************************
 * $Author: kaneda $
 * $Date: 2002/12/20 10:14:40 $
 **************************************/

/* msg.h */

#ifndef __MSG_H__
#define __MSG_H__

#include "util.h"
#include "conn.h"
#include "task.h"



/* Macro Values */
enum {
  MSG_HEADER_SIZE 	= 256
};


enum msg_type {
  SPAWN_TASK, 
  WRITE_TERMINAL,
  CLOSE_TERMINAL, 
  ASSUME_VP,
  JOIN,
  SET_ROUTE,
  GET_MACHINE_LIST,
  SEND_MACHINE_LIST
};

typedef enum msg_type	msg_type_t;


/* Structures */

struct msg {
  ph_vp_t		vp;
  task_id_t		id;
  msg_type_t 		type;

  void * 		body;
  size_t		len;
};

typedef struct msg	* msg_t;


/* Public Function Prototypes */


DEFINE_LIST_STRUCTURE(msg) 


/* Public Function Prototypes */
msg_t msg_new(ph_vp_t vp, task_id_t id, msg_type_t type, void * body, size_t len);
void msg_dispose(msg_t msg);
void msg_print(msg_t msg);

void msg_send(msg_t msg, conn_t conn);
void msg_send_raw(msg_t msg, int fd);
msg_t msg_recv(conn_t conn);
msg_t msg_recv_raw(int fd);


DEFINE_LIST_FUNC_PROTOTYPE(msg) 


void msg_list_print(msg_list_t msg_list);
msg_t msg_list_dequeue_same_dest(msg_list_t msg_list, ph_vp_t vp, task_id_t id);


#endif


