/**************************************
 * $Author: kaneda $
 * $Date: 2002/12/20 10:14:40 $
 **************************************/

/* task.h */


#ifndef __TASK_H__
#define __TASK_H__

#include "util.h"


typedef ph_vp_t		task_id_t;


enum task_type {
  EXEC, REDIR_R, REDIR_W
};

typedef enum task_type 	task_type_t;


enum task_state {
  TASK_EXECUTING, TASK_WAITING, TASK_DONE
}; 

typedef enum task_state		task_state_t;


struct task {
  ph_vp_t       	vp;
  task_id_t		id;
  task_state_t		state;
  task_type_t		type;
  char 			** argv;
  int           	argn;
  pid_t			pid;

  ph_vp_t       	in_vp;
  task_id_t     	in_id;
  char          	** in_argv;

  ph_vp_t       	out_vp;
  task_id_t     	out_id;
  char          	** out_argv;
};

typedef struct task	* task_t;


DEFINE_LIST_STRUCTURE(task) 

task_t task_new();
void argv_dispose(char ** argv);
void task_dispose(task_t task);

int task_argv2str(task_t task, char * s, size_t len);
void task_set_argv(task_t task, char * s, int argn);


DEFINE_LIST_FUNC_PROTOTYPE(task)


void task_list_print(task_list_t task_list);
task_t task_list_find_same_pid(task_list_t task_list, pid_t pid);

task_cell_t task_list_init_loop(task_list_t task_list);
task_cell_t task_list_iterate(task_list_t task_list, task_cell_t p);


#endif











