/**************************************
 * $Author: kaneda $
 * $Date: 2002/12/20 10:14:43 $
 **************************************/

/* vsh.h */


#ifndef __VSH_H__
#define __VSH_H__

#include "zsh.mdh"
#include "vpgd.h"




#define ENABLE_VSH


struct v_builtin {
  char 	* name;
  int (*func)(char **, char *, int);
};


struct vsh {
  ph_vp_t 		my_vp, host_vp;
  int			fd;

  int			is_initialized;
  int			is_interactive;

  task_list_t		tasks;
  ph_vp_range_list_t	machines;		/* list of available machine */


  task_id_t		id; /* to get fresh id (UNUSED) */
};


typedef struct vsh	* vsh_t;


/* this is defined in vsh.c */
extern vsh_t 		vsh;
extern task_t 		current_task;



/* Following functions are defined in vsh.c */

vsh_t vsh_new();
void vsh_dispose();
void vsh_print();

task_t vsh_create_new_task();

task_t vsh_setup_pipeline(Estate state, Wordcode next);
void vsh_setup_task(LinkList args, LinkList redir);
int vsh_try_remote_redirection(Redir fn);
int vsh_try_spawn_remote_task(char * pth, char ** argv);



int vsh_initialize(int is_interactive);
void vsh_finalize();

void vsh_set_pid(pid_t pid);
void vsh_delete_task(pid_t pid);

void vsh_handle_signals(int sig, pid_t pid);

void vsh_get_machine_list();

// buildin command
int bin_vpg(char *name, char **argv, char *ops, int func);
#endif




